// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vision_msgs:msg/BoundingBox2D.idl
// generated code does not contain a copyright notice
#include "vision_msgs/msg/bounding_box2_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `center`
#include "geometry_msgs/msg/pose2_d__functions.h"

bool
vision_msgs__msg__BoundingBox2D__init(vision_msgs__msg__BoundingBox2D * msg)
{
  if (!msg) {
    return false;
  }
  // center
  if (!geometry_msgs__msg__Pose2D__init(&msg->center)) {
    vision_msgs__msg__BoundingBox2D__fini(msg);
    return false;
  }
  // size_x
  // size_y
  return true;
}

void
vision_msgs__msg__BoundingBox2D__fini(vision_msgs__msg__BoundingBox2D * msg)
{
  if (!msg) {
    return;
  }
  // center
  geometry_msgs__msg__Pose2D__fini(&msg->center);
  // size_x
  // size_y
}

vision_msgs__msg__BoundingBox2D *
vision_msgs__msg__BoundingBox2D__create()
{
  vision_msgs__msg__BoundingBox2D * msg = (vision_msgs__msg__BoundingBox2D *)malloc(sizeof(vision_msgs__msg__BoundingBox2D));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vision_msgs__msg__BoundingBox2D));
  bool success = vision_msgs__msg__BoundingBox2D__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vision_msgs__msg__BoundingBox2D__destroy(vision_msgs__msg__BoundingBox2D * msg)
{
  if (msg) {
    vision_msgs__msg__BoundingBox2D__fini(msg);
  }
  free(msg);
}


bool
vision_msgs__msg__BoundingBox2D__Sequence__init(vision_msgs__msg__BoundingBox2D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vision_msgs__msg__BoundingBox2D * data = NULL;
  if (size) {
    data = (vision_msgs__msg__BoundingBox2D *)calloc(size, sizeof(vision_msgs__msg__BoundingBox2D));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vision_msgs__msg__BoundingBox2D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vision_msgs__msg__BoundingBox2D__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vision_msgs__msg__BoundingBox2D__Sequence__fini(vision_msgs__msg__BoundingBox2D__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vision_msgs__msg__BoundingBox2D__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vision_msgs__msg__BoundingBox2D__Sequence *
vision_msgs__msg__BoundingBox2D__Sequence__create(size_t size)
{
  vision_msgs__msg__BoundingBox2D__Sequence * array = (vision_msgs__msg__BoundingBox2D__Sequence *)malloc(sizeof(vision_msgs__msg__BoundingBox2D__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vision_msgs__msg__BoundingBox2D__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vision_msgs__msg__BoundingBox2D__Sequence__destroy(vision_msgs__msg__BoundingBox2D__Sequence * array)
{
  if (array) {
    vision_msgs__msg__BoundingBox2D__Sequence__fini(array);
  }
  free(array);
}
