#ifndef _H_DEFD32F4AB596E42E21C2347B949B390_BoundingBox3D_DCPS_H_
#define _H_DEFD32F4AB596E42E21C2347B949B390_BoundingBox3D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BoundingBox3D_.h"


namespace vision_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BoundingBox3D_TypeSupportInterface;

            typedef BoundingBox3D_TypeSupportInterface * BoundingBox3D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox3D_TypeSupportInterface> BoundingBox3D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BoundingBox3D_TypeSupportInterface> BoundingBox3D_TypeSupportInterface_out;


            class BoundingBox3D_DataWriter;

            typedef BoundingBox3D_DataWriter * BoundingBox3D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox3D_DataWriter> BoundingBox3D_DataWriter_var;
            typedef DDS_DCPSInterface_out < BoundingBox3D_DataWriter> BoundingBox3D_DataWriter_out;


            class BoundingBox3D_DataReader;

            typedef BoundingBox3D_DataReader * BoundingBox3D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox3D_DataReader> BoundingBox3D_DataReader_var;
            typedef DDS_DCPSInterface_out < BoundingBox3D_DataReader> BoundingBox3D_DataReader_out;


            class BoundingBox3D_DataReaderView;

            typedef BoundingBox3D_DataReaderView * BoundingBox3D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox3D_DataReaderView> BoundingBox3D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BoundingBox3D_DataReaderView> BoundingBox3D_DataReaderView_out;

            struct BoundingBox3D_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BoundingBox3D_, struct BoundingBox3D_Seq_uniq_> BoundingBox3D_Seq;
            typedef DDS_DCPSSequence_var < BoundingBox3D_Seq> BoundingBox3D_Seq_var;
            typedef DDS_DCPSSequence_out < BoundingBox3D_Seq> BoundingBox3D_Seq_out;

            class  BoundingBox3D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BoundingBox3D_TypeSupportInterface_ptr _ptr_type;
                typedef BoundingBox3D_TypeSupportInterface_var _var_type;

                static BoundingBox3D_TypeSupportInterface_ptr _duplicate (BoundingBox3D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox3D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox3D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox3D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox3D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BoundingBox3D_TypeSupportInterface () {};
                ~BoundingBox3D_TypeSupportInterface () {};
            private:
                BoundingBox3D_TypeSupportInterface (const BoundingBox3D_TypeSupportInterface &);
                BoundingBox3D_TypeSupportInterface & operator = (const BoundingBox3D_TypeSupportInterface &);
            };

            class  BoundingBox3D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BoundingBox3D_DataWriter_ptr _ptr_type;
                typedef BoundingBox3D_DataWriter_var _var_type;

                static BoundingBox3D_DataWriter_ptr _duplicate (BoundingBox3D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox3D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox3D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BoundingBox3D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BoundingBox3D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BoundingBox3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BoundingBox3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BoundingBox3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BoundingBox3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BoundingBox3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BoundingBox3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BoundingBox3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BoundingBox3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BoundingBox3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox3D_& instance_data) = 0;

            protected:
                BoundingBox3D_DataWriter () {};
                ~BoundingBox3D_DataWriter () {};
            private:
                BoundingBox3D_DataWriter (const BoundingBox3D_DataWriter &);
                BoundingBox3D_DataWriter & operator = (const BoundingBox3D_DataWriter &);
            };

            class  BoundingBox3D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BoundingBox3D_DataReader_ptr _ptr_type;
                typedef BoundingBox3D_DataReader_var _var_type;

                static BoundingBox3D_DataReader_ptr _duplicate (BoundingBox3D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox3D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox3D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox3D_& instance) = 0;

            protected:
                BoundingBox3D_DataReader () {};
                ~BoundingBox3D_DataReader () {};
            private:
                BoundingBox3D_DataReader (const BoundingBox3D_DataReader &);
                BoundingBox3D_DataReader & operator = (const BoundingBox3D_DataReader &);
            };

            class  BoundingBox3D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BoundingBox3D_DataReaderView_ptr _ptr_type;
                typedef BoundingBox3D_DataReaderView_var _var_type;

                static BoundingBox3D_DataReaderView_ptr _duplicate (BoundingBox3D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox3D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox3D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox3D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox3D_& instance) = 0;

            protected:
                BoundingBox3D_DataReaderView () {};
                ~BoundingBox3D_DataReaderView () {};
            private:
                BoundingBox3D_DataReaderView (const BoundingBox3D_DataReaderView &);
                BoundingBox3D_DataReaderView & operator = (const BoundingBox3D_DataReaderView &);
            };
        }

    }

}

#endif
