#ifndef _H_D0A2811FA14EAB74BD9CF834AE61C93B_Detection2D__H_
#define _H_D0A2811FA14EAB74BD9CF834AE61C93B_Detection2D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "vision_msgs/msg/dds_opensplice/ObjectHypothesisWithPose_.h"
#include "vision_msgs/msg/dds_opensplice/BoundingBox2D_.h"
#include "sensor_msgs/msg/dds_opensplice/Image_.h"


namespace vision_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Detection2D_
            {
                struct _results__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::vision_msgs::msg::dds_::ObjectHypothesisWithPose_, struct _results__seq_uniq_ > _results__seq;
                typedef DDS_DCPSSequence_var< _results__seq > _results__seq_var;
                typedef DDS_DCPSSequence_out< _results__seq > _results__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                _results__seq results_;
                ::vision_msgs::msg::dds_::BoundingBox2D_ bbox_;
                ::sensor_msgs::msg::dds_::Image_ source_img_;
                ::DDS::Boolean is_tracking_;
                ::DDS::String_mgr tracking_id_;
            };

            typedef DDS_DCPSStruct_var<Detection2D_> Detection2D__var;
            typedef DDS_DCPSStruct_out < Detection2D_> Detection2D__out;

        }

    }

}

#endif /* _H_D0A2811FA14EAB74BD9CF834AE61C93B_Detection2D__H_ */
