#ifndef _H_897F25BA7D33013BE6DFE46A4628B75E_Detection3D__H_
#define _H_897F25BA7D33013BE6DFE46A4628B75E_Detection3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "vision_msgs/msg/dds_opensplice/ObjectHypothesisWithPose_.h"
#include "vision_msgs/msg/dds_opensplice/BoundingBox3D_.h"
#include "sensor_msgs/msg/dds_opensplice/PointCloud2_.h"


namespace vision_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Detection3D_
            {
                struct _results__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::vision_msgs::msg::dds_::ObjectHypothesisWithPose_, struct _results__seq_uniq_ > _results__seq;
                typedef DDS_DCPSSequence_var< _results__seq > _results__seq_var;
                typedef DDS_DCPSSequence_out< _results__seq > _results__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                _results__seq results_;
                ::vision_msgs::msg::dds_::BoundingBox3D_ bbox_;
                ::sensor_msgs::msg::dds_::PointCloud2_ source_cloud_;
                ::DDS::Boolean is_tracking_;
                ::DDS::String_mgr tracking_id_;
            };

            typedef DDS_DCPSStruct_var<Detection3D_> Detection3D__var;
            typedef DDS_DCPSStruct_out < Detection3D_> Detection3D__out;

        }

    }

}

#endif /* _H_897F25BA7D33013BE6DFE46A4628B75E_Detection3D__H_ */
