#ifndef H_897F25BA7D33013BE6DFE46A4628B75E_Detection3D_SPLTYPES_H
#define H_897F25BA7D33013BE6DFE46A4628B75E_Detection3D_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Detection3D_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "vision_msgs/msg/dds_opensplice/ObjectHypothesisWithPose_SplDcps.h"
#include "vision_msgs/msg/dds_opensplice/BoundingBox3D_SplDcps.h"
#include "sensor_msgs/msg/dds_opensplice/PointCloud2_SplDcps.h"



extern c_metaObject __Detection3D__vision_msgs__load (c_base base);

extern c_metaObject __Detection3D__vision_msgs_msg__load (c_base base);

extern c_metaObject __Detection3D__vision_msgs_msg_dds___load (c_base base);

extern const char *vision_msgs_msg_dds__Detection3D__metaDescriptor[];
extern const int vision_msgs_msg_dds__Detection3D__metaDescriptorArrLength;
extern const int vision_msgs_msg_dds__Detection3D__metaDescriptorLength;
extern c_metaObject __vision_msgs_msg_dds__Detection3D___load (c_base base);
struct _vision_msgs_msg_dds__Detection3D_ ;
extern  v_copyin_result __vision_msgs_msg_dds__Detection3D___copyIn(c_base base, const struct vision_msgs::msg::dds_::Detection3D_ *from, struct _vision_msgs_msg_dds__Detection3D_ *to);
extern  void __vision_msgs_msg_dds__Detection3D___copyOut(const void *_from, void *_to);
struct _vision_msgs_msg_dds__Detection3D_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_sequence results_;
    struct _vision_msgs_msg_dds__BoundingBox3D_ bbox_;
    struct _sensor_msgs_msg_dds__PointCloud2_ source_cloud_;
    c_bool is_tracking_;
    c_string tracking_id_;
};

#undef OS_API
#endif
