// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vision_msgs:msg/ObjectHypothesisWithPose.idl
// generated code does not contain a copyright notice
#include "vision_msgs/msg/object_hypothesis_with_pose__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `id`
#include "rosidl_generator_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose_with_covariance__functions.h"

bool
vision_msgs__msg__ObjectHypothesisWithPose__init(vision_msgs__msg__ObjectHypothesisWithPose * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_generator_c__String__init(&msg->id)) {
    vision_msgs__msg__ObjectHypothesisWithPose__fini(msg);
    return false;
  }
  // score
  // pose
  if (!geometry_msgs__msg__PoseWithCovariance__init(&msg->pose)) {
    vision_msgs__msg__ObjectHypothesisWithPose__fini(msg);
    return false;
  }
  return true;
}

void
vision_msgs__msg__ObjectHypothesisWithPose__fini(vision_msgs__msg__ObjectHypothesisWithPose * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_generator_c__String__fini(&msg->id);
  // score
  // pose
  geometry_msgs__msg__PoseWithCovariance__fini(&msg->pose);
}

vision_msgs__msg__ObjectHypothesisWithPose *
vision_msgs__msg__ObjectHypothesisWithPose__create()
{
  vision_msgs__msg__ObjectHypothesisWithPose * msg = (vision_msgs__msg__ObjectHypothesisWithPose *)malloc(sizeof(vision_msgs__msg__ObjectHypothesisWithPose));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vision_msgs__msg__ObjectHypothesisWithPose));
  bool success = vision_msgs__msg__ObjectHypothesisWithPose__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vision_msgs__msg__ObjectHypothesisWithPose__destroy(vision_msgs__msg__ObjectHypothesisWithPose * msg)
{
  if (msg) {
    vision_msgs__msg__ObjectHypothesisWithPose__fini(msg);
  }
  free(msg);
}


bool
vision_msgs__msg__ObjectHypothesisWithPose__Sequence__init(vision_msgs__msg__ObjectHypothesisWithPose__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vision_msgs__msg__ObjectHypothesisWithPose * data = NULL;
  if (size) {
    data = (vision_msgs__msg__ObjectHypothesisWithPose *)calloc(size, sizeof(vision_msgs__msg__ObjectHypothesisWithPose));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vision_msgs__msg__ObjectHypothesisWithPose__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vision_msgs__msg__ObjectHypothesisWithPose__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vision_msgs__msg__ObjectHypothesisWithPose__Sequence__fini(vision_msgs__msg__ObjectHypothesisWithPose__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vision_msgs__msg__ObjectHypothesisWithPose__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vision_msgs__msg__ObjectHypothesisWithPose__Sequence *
vision_msgs__msg__ObjectHypothesisWithPose__Sequence__create(size_t size)
{
  vision_msgs__msg__ObjectHypothesisWithPose__Sequence * array = (vision_msgs__msg__ObjectHypothesisWithPose__Sequence *)malloc(sizeof(vision_msgs__msg__ObjectHypothesisWithPose__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vision_msgs__msg__ObjectHypothesisWithPose__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vision_msgs__msg__ObjectHypothesisWithPose__Sequence__destroy(vision_msgs__msg__ObjectHypothesisWithPose__Sequence * array)
{
  if (array) {
    vision_msgs__msg__ObjectHypothesisWithPose__Sequence__fini(array);
  }
  free(array);
}
