// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vision_msgs:msg/BoundingBox3D.idl
// generated code does not contain a copyright notice

#ifndef VISION_MSGS__MSG__BOUNDING_BOX3_D__FUNCTIONS_H_
#define VISION_MSGS__MSG__BOUNDING_BOX3_D__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "vision_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "vision_msgs/msg/bounding_box3_d__struct.h"

/// Initialize msg/BoundingBox3D message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * vision_msgs__msg__BoundingBox3D
 * )) before or use
 * vision_msgs__msg__BoundingBox3D__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
bool
vision_msgs__msg__BoundingBox3D__init(vision_msgs__msg__BoundingBox3D * msg);

/// Finalize msg/BoundingBox3D message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__BoundingBox3D__fini(vision_msgs__msg__BoundingBox3D * msg);

/// Create msg/BoundingBox3D message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * vision_msgs__msg__BoundingBox3D__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
vision_msgs__msg__BoundingBox3D *
vision_msgs__msg__BoundingBox3D__create();

/// Destroy msg/BoundingBox3D message.
/**
 * It calls
 * vision_msgs__msg__BoundingBox3D__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__BoundingBox3D__destroy(vision_msgs__msg__BoundingBox3D * msg);


/// Initialize array of msg/BoundingBox3D messages.
/**
 * It allocates the memory for the number of elements and calls
 * vision_msgs__msg__BoundingBox3D__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
bool
vision_msgs__msg__BoundingBox3D__Sequence__init(vision_msgs__msg__BoundingBox3D__Sequence * array, size_t size);

/// Finalize array of msg/BoundingBox3D messages.
/**
 * It calls
 * vision_msgs__msg__BoundingBox3D__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__BoundingBox3D__Sequence__fini(vision_msgs__msg__BoundingBox3D__Sequence * array);

/// Create array of msg/BoundingBox3D messages.
/**
 * It allocates the memory for the array and calls
 * vision_msgs__msg__BoundingBox3D__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
vision_msgs__msg__BoundingBox3D__Sequence *
vision_msgs__msg__BoundingBox3D__Sequence__create(size_t size);

/// Destroy array of msg/BoundingBox3D messages.
/**
 * It calls
 * vision_msgs__msg__BoundingBox3D__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vision_msgs
void
vision_msgs__msg__BoundingBox3D__Sequence__destroy(vision_msgs__msg__BoundingBox3D__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // VISION_MSGS__MSG__BOUNDING_BOX3_D__FUNCTIONS_H_
