// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vision_msgs:msg/Classification3D.idl
// generated code does not contain a copyright notice
#include "vision_msgs/msg/classification3_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `results`
#include "vision_msgs/msg/object_hypothesis__functions.h"
// Member `source_cloud`
#include "sensor_msgs/msg/point_cloud2__functions.h"

bool
vision_msgs__msg__Classification3D__init(vision_msgs__msg__Classification3D * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vision_msgs__msg__Classification3D__fini(msg);
    return false;
  }
  // results
  if (!vision_msgs__msg__ObjectHypothesis__Sequence__init(&msg->results, 0)) {
    vision_msgs__msg__Classification3D__fini(msg);
    return false;
  }
  // source_cloud
  if (!sensor_msgs__msg__PointCloud2__init(&msg->source_cloud)) {
    vision_msgs__msg__Classification3D__fini(msg);
    return false;
  }
  return true;
}

void
vision_msgs__msg__Classification3D__fini(vision_msgs__msg__Classification3D * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // results
  vision_msgs__msg__ObjectHypothesis__Sequence__fini(&msg->results);
  // source_cloud
  sensor_msgs__msg__PointCloud2__fini(&msg->source_cloud);
}

vision_msgs__msg__Classification3D *
vision_msgs__msg__Classification3D__create()
{
  vision_msgs__msg__Classification3D * msg = (vision_msgs__msg__Classification3D *)malloc(sizeof(vision_msgs__msg__Classification3D));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vision_msgs__msg__Classification3D));
  bool success = vision_msgs__msg__Classification3D__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vision_msgs__msg__Classification3D__destroy(vision_msgs__msg__Classification3D * msg)
{
  if (msg) {
    vision_msgs__msg__Classification3D__fini(msg);
  }
  free(msg);
}


bool
vision_msgs__msg__Classification3D__Sequence__init(vision_msgs__msg__Classification3D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vision_msgs__msg__Classification3D * data = NULL;
  if (size) {
    data = (vision_msgs__msg__Classification3D *)calloc(size, sizeof(vision_msgs__msg__Classification3D));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vision_msgs__msg__Classification3D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vision_msgs__msg__Classification3D__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vision_msgs__msg__Classification3D__Sequence__fini(vision_msgs__msg__Classification3D__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vision_msgs__msg__Classification3D__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vision_msgs__msg__Classification3D__Sequence *
vision_msgs__msg__Classification3D__Sequence__create(size_t size)
{
  vision_msgs__msg__Classification3D__Sequence * array = (vision_msgs__msg__Classification3D__Sequence *)malloc(sizeof(vision_msgs__msg__Classification3D__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vision_msgs__msg__Classification3D__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vision_msgs__msg__Classification3D__Sequence__destroy(vision_msgs__msg__Classification3D__Sequence * array)
{
  if (array) {
    vision_msgs__msg__Classification3D__Sequence__fini(array);
  }
  free(array);
}
