#ifndef _H_F1853C1CD0683F1FCD8FA8E04526E01E_BoundingBox2D_DCPS_H_
#define _H_F1853C1CD0683F1FCD8FA8E04526E01E_BoundingBox2D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BoundingBox2D_.h"


namespace vision_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BoundingBox2D_TypeSupportInterface;

            typedef BoundingBox2D_TypeSupportInterface * BoundingBox2D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox2D_TypeSupportInterface> BoundingBox2D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BoundingBox2D_TypeSupportInterface> BoundingBox2D_TypeSupportInterface_out;


            class BoundingBox2D_DataWriter;

            typedef BoundingBox2D_DataWriter * BoundingBox2D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox2D_DataWriter> BoundingBox2D_DataWriter_var;
            typedef DDS_DCPSInterface_out < BoundingBox2D_DataWriter> BoundingBox2D_DataWriter_out;


            class BoundingBox2D_DataReader;

            typedef BoundingBox2D_DataReader * BoundingBox2D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox2D_DataReader> BoundingBox2D_DataReader_var;
            typedef DDS_DCPSInterface_out < BoundingBox2D_DataReader> BoundingBox2D_DataReader_out;


            class BoundingBox2D_DataReaderView;

            typedef BoundingBox2D_DataReaderView * BoundingBox2D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox2D_DataReaderView> BoundingBox2D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BoundingBox2D_DataReaderView> BoundingBox2D_DataReaderView_out;

            struct BoundingBox2D_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BoundingBox2D_, struct BoundingBox2D_Seq_uniq_> BoundingBox2D_Seq;
            typedef DDS_DCPSSequence_var < BoundingBox2D_Seq> BoundingBox2D_Seq_var;
            typedef DDS_DCPSSequence_out < BoundingBox2D_Seq> BoundingBox2D_Seq_out;

            class  BoundingBox2D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BoundingBox2D_TypeSupportInterface_ptr _ptr_type;
                typedef BoundingBox2D_TypeSupportInterface_var _var_type;

                static BoundingBox2D_TypeSupportInterface_ptr _duplicate (BoundingBox2D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox2D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox2D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox2D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox2D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BoundingBox2D_TypeSupportInterface () {};
                ~BoundingBox2D_TypeSupportInterface () {};
            private:
                BoundingBox2D_TypeSupportInterface (const BoundingBox2D_TypeSupportInterface &);
                BoundingBox2D_TypeSupportInterface & operator = (const BoundingBox2D_TypeSupportInterface &);
            };

            class  BoundingBox2D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BoundingBox2D_DataWriter_ptr _ptr_type;
                typedef BoundingBox2D_DataWriter_var _var_type;

                static BoundingBox2D_DataWriter_ptr _duplicate (BoundingBox2D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox2D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox2D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BoundingBox2D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BoundingBox2D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BoundingBox2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BoundingBox2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BoundingBox2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BoundingBox2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BoundingBox2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BoundingBox2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BoundingBox2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BoundingBox2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BoundingBox2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox2D_& instance_data) = 0;

            protected:
                BoundingBox2D_DataWriter () {};
                ~BoundingBox2D_DataWriter () {};
            private:
                BoundingBox2D_DataWriter (const BoundingBox2D_DataWriter &);
                BoundingBox2D_DataWriter & operator = (const BoundingBox2D_DataWriter &);
            };

            class  BoundingBox2D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BoundingBox2D_DataReader_ptr _ptr_type;
                typedef BoundingBox2D_DataReader_var _var_type;

                static BoundingBox2D_DataReader_ptr _duplicate (BoundingBox2D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox2D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox2D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox2D_& instance) = 0;

            protected:
                BoundingBox2D_DataReader () {};
                ~BoundingBox2D_DataReader () {};
            private:
                BoundingBox2D_DataReader (const BoundingBox2D_DataReader &);
                BoundingBox2D_DataReader & operator = (const BoundingBox2D_DataReader &);
            };

            class  BoundingBox2D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BoundingBox2D_DataReaderView_ptr _ptr_type;
                typedef BoundingBox2D_DataReaderView_var _var_type;

                static BoundingBox2D_DataReaderView_ptr _duplicate (BoundingBox2D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox2D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox2D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox2D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox2D_& instance) = 0;

            protected:
                BoundingBox2D_DataReaderView () {};
                ~BoundingBox2D_DataReaderView () {};
            private:
                BoundingBox2D_DataReaderView (const BoundingBox2D_DataReaderView &);
                BoundingBox2D_DataReaderView & operator = (const BoundingBox2D_DataReaderView &);
            };
        }

    }

}

#endif
