#ifndef _H_BA686EDF23C70F5A6801DD0DB5B1B59A_Classification3D_DCPS_H_
#define _H_BA686EDF23C70F5A6801DD0DB5B1B59A_Classification3D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Classification3D_.h"


namespace vision_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Classification3D_TypeSupportInterface;

            typedef Classification3D_TypeSupportInterface * Classification3D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Classification3D_TypeSupportInterface> Classification3D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Classification3D_TypeSupportInterface> Classification3D_TypeSupportInterface_out;


            class Classification3D_DataWriter;

            typedef Classification3D_DataWriter * Classification3D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Classification3D_DataWriter> Classification3D_DataWriter_var;
            typedef DDS_DCPSInterface_out < Classification3D_DataWriter> Classification3D_DataWriter_out;


            class Classification3D_DataReader;

            typedef Classification3D_DataReader * Classification3D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Classification3D_DataReader> Classification3D_DataReader_var;
            typedef DDS_DCPSInterface_out < Classification3D_DataReader> Classification3D_DataReader_out;


            class Classification3D_DataReaderView;

            typedef Classification3D_DataReaderView * Classification3D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Classification3D_DataReaderView> Classification3D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Classification3D_DataReaderView> Classification3D_DataReaderView_out;

            struct Classification3D_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Classification3D_, struct Classification3D_Seq_uniq_> Classification3D_Seq;
            typedef DDS_DCPSSequence_var < Classification3D_Seq> Classification3D_Seq_var;
            typedef DDS_DCPSSequence_out < Classification3D_Seq> Classification3D_Seq_out;

            class  Classification3D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Classification3D_TypeSupportInterface_ptr _ptr_type;
                typedef Classification3D_TypeSupportInterface_var _var_type;

                static Classification3D_TypeSupportInterface_ptr _duplicate (Classification3D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Classification3D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Classification3D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Classification3D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Classification3D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Classification3D_TypeSupportInterface () {};
                ~Classification3D_TypeSupportInterface () {};
            private:
                Classification3D_TypeSupportInterface (const Classification3D_TypeSupportInterface &);
                Classification3D_TypeSupportInterface & operator = (const Classification3D_TypeSupportInterface &);
            };

            class  Classification3D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Classification3D_DataWriter_ptr _ptr_type;
                typedef Classification3D_DataWriter_var _var_type;

                static Classification3D_DataWriter_ptr _duplicate (Classification3D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Classification3D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Classification3D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Classification3D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Classification3D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Classification3D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Classification3D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Classification3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Classification3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Classification3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Classification3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Classification3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Classification3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Classification3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Classification3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Classification3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Classification3D_& instance_data) = 0;

            protected:
                Classification3D_DataWriter () {};
                ~Classification3D_DataWriter () {};
            private:
                Classification3D_DataWriter (const Classification3D_DataWriter &);
                Classification3D_DataWriter & operator = (const Classification3D_DataWriter &);
            };

            class  Classification3D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Classification3D_DataReader_ptr _ptr_type;
                typedef Classification3D_DataReader_var _var_type;

                static Classification3D_DataReader_ptr _duplicate (Classification3D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Classification3D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Classification3D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Classification3D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Classification3D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Classification3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Classification3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Classification3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Classification3D_& instance) = 0;

            protected:
                Classification3D_DataReader () {};
                ~Classification3D_DataReader () {};
            private:
                Classification3D_DataReader (const Classification3D_DataReader &);
                Classification3D_DataReader & operator = (const Classification3D_DataReader &);
            };

            class  Classification3D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Classification3D_DataReaderView_ptr _ptr_type;
                typedef Classification3D_DataReaderView_var _var_type;

                static Classification3D_DataReaderView_ptr _duplicate (Classification3D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Classification3D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Classification3D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Classification3D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Classification3D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Classification3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Classification3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Classification3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Classification3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Classification3D_& instance) = 0;

            protected:
                Classification3D_DataReaderView () {};
                ~Classification3D_DataReaderView () {};
            private:
                Classification3D_DataReaderView (const Classification3D_DataReaderView &);
                Classification3D_DataReaderView & operator = (const Classification3D_DataReaderView &);
            };
        }

    }

}

#endif
