// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vision_msgs:msg/VisionInfo.idl
// generated code does not contain a copyright notice
#include "vision_msgs/msg/vision_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `method`
// Member `database_location`
#include "rosidl_generator_c/string_functions.h"

bool
vision_msgs__msg__VisionInfo__init(vision_msgs__msg__VisionInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vision_msgs__msg__VisionInfo__fini(msg);
    return false;
  }
  // method
  if (!rosidl_generator_c__String__init(&msg->method)) {
    vision_msgs__msg__VisionInfo__fini(msg);
    return false;
  }
  // database_location
  if (!rosidl_generator_c__String__init(&msg->database_location)) {
    vision_msgs__msg__VisionInfo__fini(msg);
    return false;
  }
  // database_version
  return true;
}

void
vision_msgs__msg__VisionInfo__fini(vision_msgs__msg__VisionInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // method
  rosidl_generator_c__String__fini(&msg->method);
  // database_location
  rosidl_generator_c__String__fini(&msg->database_location);
  // database_version
}

vision_msgs__msg__VisionInfo *
vision_msgs__msg__VisionInfo__create()
{
  vision_msgs__msg__VisionInfo * msg = (vision_msgs__msg__VisionInfo *)malloc(sizeof(vision_msgs__msg__VisionInfo));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vision_msgs__msg__VisionInfo));
  bool success = vision_msgs__msg__VisionInfo__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vision_msgs__msg__VisionInfo__destroy(vision_msgs__msg__VisionInfo * msg)
{
  if (msg) {
    vision_msgs__msg__VisionInfo__fini(msg);
  }
  free(msg);
}


bool
vision_msgs__msg__VisionInfo__Sequence__init(vision_msgs__msg__VisionInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vision_msgs__msg__VisionInfo * data = NULL;
  if (size) {
    data = (vision_msgs__msg__VisionInfo *)calloc(size, sizeof(vision_msgs__msg__VisionInfo));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vision_msgs__msg__VisionInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vision_msgs__msg__VisionInfo__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vision_msgs__msg__VisionInfo__Sequence__fini(vision_msgs__msg__VisionInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vision_msgs__msg__VisionInfo__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vision_msgs__msg__VisionInfo__Sequence *
vision_msgs__msg__VisionInfo__Sequence__create(size_t size)
{
  vision_msgs__msg__VisionInfo__Sequence * array = (vision_msgs__msg__VisionInfo__Sequence *)malloc(sizeof(vision_msgs__msg__VisionInfo__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vision_msgs__msg__VisionInfo__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vision_msgs__msg__VisionInfo__Sequence__destroy(vision_msgs__msg__VisionInfo__Sequence * array)
{
  if (array) {
    vision_msgs__msg__VisionInfo__Sequence__fini(array);
  }
  free(array);
}
